function [x1,iter,res]=aitken(g,x0,tol,maxiter)
% This function implements the Aitken's acceleration of
%  the fixed-point iteration method with iteration
%    function g and start point x0.
iter=1; x1=realmax; res=[realmax]
while (res(end)>tol && iter<maxiter)
    xa=g(x0);
    xb=g(xa);
    delta=xa-x0;
    deltasq=xb-2*xa+x0;
    x1=x0-delta^2/deltasq;
    res(iter)=abs(x1-x0)/abs(x0); iter=iter+1; x0=x1;
end
if iter>=maxiter
    disp('Warning: the Aitken''s algorithm did not converge!');
end
iter=iter-1;
