clear all; close all;
% punto a)
f=@(x) 2* sin(x)-x;
x=linspace(1,3);
plot(x,f(x)); grid;
%lo zero si trova in (1.8,2)

% punto b)
g=@(x) 2*sin(x);
x0=1.8;
[xbar_g,k_g,err_g,flag]=MetodoIterativo(g,x0,1.e-8,100);
if flag==1
 disp(fprintf('g(x)   soluzione= %f    iter= %d    err= %e',xbar_g,k_g,err_g(end)));
end
% usando g(x) e' garantita la convergenza, in quanto 
% g'(x)=2cos(x) ha valore assoluto minore di 1 intorno a xbar
% verifica:
%gp= @(x) abs(2*cos(x));
%plot(x,gp(x)); grid;

% punto c)
h=@(x) asin(x./2);
[xbar_h,k_h,err_h,flag]=MetodoIterativo(h,x0,1.e-8,100);
if flag==1
disp(fprintf('h(x)   soluzione= %f    iter= %d  err= %e',xbar_h,k_h,err_h(end)));
end
% usando h(x) non arrivo a convergenza, del resto h'(x)=1./sqrt(4-x.^2), il cui valore assoluto è maggiore di 1 intorno a xbar e la convergenza non è garantita.
% verifica:
%hp= @(x) abs(1./sqrt(4-x.^2));
%plot(x,hp(x)); grid;

%punto d)
[x_ait,k_ait,err_ait]=aitken(g,x0,1.e-8,100);
disp(fprintf('Aitken  soluzione= %f    iter= %d    err= %e',x_ait,k_ait,err_ait(end)));
semilogy(err_g); hold on;
semilogy(err_ait);
%il metodo di iterazione di punto fisso ha convergenza lineare, mentre la sua accelerazione di Aitken converge con ordine almeno 2.
legend('punto fisso','Aitken')