clear all; close all;
A=[9 0 4 0 4; 0 4 0 3 0; 0 1 5 1 2; 2 0 0 -7 2; 0 5 0 1 -6];
b=A*ones(5,1);
x0=[1 0 1 0 1]'; tol=1.e-6;
kmax=100;

%prima parte
D=diag(diag(A));
J=inv(D)*(D-A);
q1=inv(D)*b;
rhoJ=max(abs(eig(J)));
disp(['Raggio spetrale di J = ',num2str(rhoJ)]);
% si nota che A è diagonalmente dominante per righe in senso stretto, quindi
% la convergenza di Jacobi e Gauss-Siedel è garantita, anche se la matrice di
% iterazione di Jacobi abbia raggio spettrale maggiore di 1.
[xJ,iterJ,errJ]=iterative(J,q1,x0,tol,kmax);
disp(['Numero di iterazioni per J = ',num2str(iterJ)]);
disp('');
%seconda parte
B=-(tril(A)-D); C=-(triu(A)-D);
GS=inv(D-B)*C;
q2=inv(D-B)*b;
rhoGS=max(abs(eig(GS)));
disp(['Raggio spetrale di GS = ',num2str(rhoGS)]);
% il raggio spettrale di GS è quasi la metà di quello di J,
% quindi ci si aspetta una convergenza più veloce.
[xGS,iterGS,errGS]=iterative(GS,q2,x0,tol,kmax);
disp(['Numero di iterazioni per GS = ',num2str(iterGS)]);

semilogy(errJ); hold on
semilogy(errGS);
legend('Jacobi','Gauss-Seidel');
